addpath ('C:\Users\lange184\OneDrive - WageningenUR\Voorbereiding-lab_Gedeelde-map\Data\LISST') %path with data
addpath ('C:\Users\lange184\OneDrive - WageningenUR\Voorbereiding-lab_Gedeelde-map\Scripts\functions'); %add this map for called functions

%% read data
cd ('C:\Users\lange184\OneDrive - WageningenUR\TechnicalNote_GrainSize\Data\alldata\') %cd to data

%when .rbn files
clear files data
files = dir('*.RBN') ;
for i = 1:length(files)
    try
    data{i} = getscat_L200X(files(i).name);
    catch
    end
end

clear vd dias
for i = 1:size(data,2)
  [vd{i}, dias{i}] = invert_L200X(data{i}.cscat,1,1,0);
  % metadata
    measav(i) = data{i}.config.measurementAve;
    smpint(i) = data{i}.config.sampleInterval; 
    tme{i} = data{i}.date - data{i}.date(1);
end


%when .csv files
clear files data
files = dir('*.csv') ;
for i = 1:length(files)
%     try
    temp =  table2array(readtable(files(i).name) ) ;
    temp = temp(~isnan(temp(:,1)),:);
    vd{i} = temp(:,[1:36]);   
    dias{i} = [1.21453098842274,1.60239947521677,1.89094101287590,2.23143976859604,2.63325159640965,3.10741704417891,3.66696471374754,4.32726924667516,5.10647377189618,6.02598842286021,7.11107862186502,8.39155929581824,9.90261409833281,11.6857621478486,13.7899988447577,16.2731421136642,19.2034210613573,22.6613507019109,26.7419442605661,31.5573238436720,37.2398012078313,43.9455132782712,51.8587123092535,61.1968285668802,72.2164446411807,85.2203455431217,100.565838301429,118.674569656042,140.044111608093,165.261633161536,195.020033913656,230.136982795687,272.626933166314,324.209888662752,385.552706351985,458.502021602336];
    tmptime = temp(:,43:48);
    tmetmp{i} = datenum(datestr(tmptime, 'yyyy-mm-dd__HH:MM:SS'));
    tme{i} = tmetmp{i} - tmetmp{i}(1);

    smpint(i) = ((tme{i}(end)-tme{i}(1))*24*3600)/length(tme{i});
     
%     if abs(smpint(i)) == 58
%         smpint(i) = 2;
%     elseif abs(smpin(i))==59
%         smpint(i)=1;
%     end
    clear temp tmptime
%     catch
%     end
end


% %check data
% figure; hold on,
% for i = 1:length(files)
% plot(dias{i}, mean(vd{i}))
% end

%% perform monte carlo analysis
tst = 1000;%amount of tests

for run = 1:length(vd)
    sp = vd{run};
    if size(sp,1) > 100
    steps{run} =[2:100, 100:10:size(sp,1)] ; %amount of samples taken for averaging
    else
    steps{run} =[2:size(sp,1)];  %amount of samples taken for averaging
    end  
    
    for n = 1:length(steps{run})
        i = steps{run}(n);
        for k = 1:tst 
            rw = randsample(size(sp,1), i);
            rs = sp(rw,:);
            meanrs{run}{n}(k,:) = nanmean(rs);
            clear rs rw
        end
    end
end



%% get D50 per average (and D10 and D90)
clear D50 D90 D10 i n

    yval50=50; %evaluate at 50 percentile for D50
    yvall0=10; %evaluate at 50 percentile for D50
    yval90=90; %evaluate at 50 percentile for D50
    
for run = 1:length(vd)
    %normalize distribution
    for i = 1:length(meanrs{run})
        for n = 1:size(meanrs{run}{i},1)
            meanrsnorm{run}{i}(n,:) = meanrs{run}{i}(n,:) / sum(meanrs{run}{i}(n,:)) * 100;
            meanrscum{run}{i}(n,:) = cumsum(meanrsnorm{run}{i}(n,:));
        end
    end
    

    %fit smoothign spline
    for i = 1:length(meanrs{run})
        for n = 1:size(meanrs{run}{i},1)
            if sum(isnan(meanrscum{run}{i}(n,:)))==36 %if line consists of only NaNs (errorenous run)
                continue
            else
            f=fit(dias{1}', meanrscum{run}{i}(n,:)', 'smoothingspline');
            % figure; plot(f, dias{1}, meanrscum{1}(1,:))
            eqn=@(x)feval(f,x)-yval50;
            D50{run}{i}(:,n)=fzero(eqn,50);
            clear  eqn 
            eqn=@(x)feval(f,x)-yvall0;
            D10{run}{i}(:,n)=fzero(eqn,10);
            clear  eqn
            eqn=@(x)feval(f,x)-yval90;
            D90{run}{i}(:,n)=fzero(eqn,90);
            clear f eqn 
            end
        end
    end
   D50_act(run) = mean(D50{run}{length(steps{run})}); 
   D10_act(run) = mean(D10{run}{length(steps{run})}); 
   D90_act(run) = mean(D90{run}{length(steps{run})}); 
end



%% get statistics of each sample
Stats = table;
Stats.width = ((D90_act-D10_act)./D50_act)'; %(D90-D10)/D50
Stats.D10 = D10_act';
Stats.D50 = D50_act';
Stats.D90 = D90_act';

figure; hist(Stats.width, 30); xlabel ('(D90-D10)/D50')
figure; hist(Stats.D50, 30); xlabel ('D50') %set(gca, 'XScale', 'log'); 

%% determine bimodality
clear idx
bim = zeros(233,1);
for i = 1:length(vd)
[pks{i}, locs{i}] = findpeaks(mean(vd{i}),dias{i});
pkmx(i) = max(pks{i});
idx{i} = find (pks{i}>=0.5*pkmx(i));
    if length(idx{i})>=2
        bim(i) = 1;
    end
end

Stats.bim = bim;

%% determine upper and ower limit of D50
clear upbound downbound D50act
for i = 1:size(D50,2)
        for k = 1:size(D50{i},2)
        upbound{i}(k) = max(D50{i}{k});
        downbound{i}(k) = min(D50{i}{k});
        end
end

figure; hold on,
for i = 1:length(steps)
    plot(steps{i}, upbound{i}-D50_act(i))
    plot(steps{i}, downbound{i}-D50_act(i))
end

%% get required time/samples for cutof 0.05
cutoff = 0.05; 

clear idx_down idx_up idx
for i = 1:length(D50_act)
    try
    idx_down{i} = find(gradient(smooth(downbound{i}-D50_act(i), 20))<cutoff);
    idx_up{i} = find(gradient(smooth(upbound{i}-D50_act(i), 20))>-1*cutoff);
    if idx_down{i}(1) > idx_up{i}(1)
        idx(i) = idx_down{i}(1);
    end
    if idx_up{i}(1) > idx_down{i}(1) || idx_up{i}(1) == idx_down{i}(1)
        idx(i)= idx_up{i}(1);
    end
    catch
        not(i) = i; %for this samples, the threshold is not reached
    end
end

% sum(idx == 0) %for this many samples, the threshold is not reached


% amount of samples needed to reach cutoff level
for i = 1:length(D50_act)
    try
    smp(i) = steps{i}(idx(i));
    timereq(i) = datetime(tme{i}(idx(i)), 'ConvertFrom', 'datenum');%time needed to reach requirement
    catch
    end
end
Stats.samples = smp';
Stats.time = minute(timereq')*60 + second(timereq'); %in amount of seconds

%table with various cutofss
Statsthres = table;
Statsthres.samples1 = smp';
Statsthres.time1= minute(timereq')*60 + second(timereq');

%% get required time/samples for cutof 0.005
cutoff = 0.005; 

clear idx_down idx_up idx
for i = 1:length(D50_act)
    try
    idx_down{i} = find(gradient(smooth(downbound{i}-D50_act(i), 20))<cutoff);
    idx_up{i} = find(gradient(smooth(upbound{i}-D50_act(i), 20))>-1*cutoff);
    if idx_down{i}(1) > idx_up{i}(1)
        idx(i) = idx_down{i}(1);
    end
    if idx_up{i}(1) > idx_down{i}(1) || idx_up{i}(1) == idx_down{i}(1)
        idx(i)= idx_up{i}(1);
    end
    catch
        not(i) = i; %for this samples, the threshold is not reached
    end
end

% sum(idx == 0) %for this many samples, the threshold is not reached

% amount of samples needed to reach cutoff level
for i = 1:length(D50_act)
    try
    smp(i) = steps{i}(idx(i));
    timereq(i) = datetime(tme{i}(idx(i)), 'ConvertFrom', 'datenum');%time needed to reach requirement
    catch
    end
end

Statsthres.samples2 = smp';
Statsthres.time2= minute(timereq')*60 + second(timereq');


%% %% get required time/samples for 5% deviation
for i= 1:length(D50_act)
    try
limup(i)  = (min(find ((D50_act(i)/20)>upbound{i}-D50_act(i)))); %5% deviation for upbound
limdown(i) = (min(find ((-D50_act(i)/20)<downbound{i}-D50_act(i)))); %5% deviation for downbouwnd

    if limup(i) >= limdown(i)
        lim(i) = limup(i);
    elseif limdown(i) > limup(i)
        lim(i) = limdown(i);
    end
    catch
    end
end

lim(lim == 0) = NaN;

for i = 1:length(D50_act)
    try
    smp3(i) = steps{i}(lim(i));
    timereq3(i) = datetime(tme{i}(lim(i)), 'ConvertFrom', 'datenum');%time needed to reach requirement
    catch
    end
end

Statsthres.samples3 = smp3';
Statsthres.time3= minute(timereq3')*60 + second(timereq3');
Statsthres.time3(Statsthres.time3==0,:) = 1; %correct for time if first sample is already enough

%% figure for paper
% lab: storage (162:233), settings (157:161), tank (131:156), hucherange (37:83, 108:131)
% field: rotterdam (1:36), everlange (84:107)
idxstor = [37:83, 131:233];


figure; 
% thres1: cutoff = 0.05
subplot(1,3,1), hold on,
scatter (Stats.D50, Stats.width, 50, Statsthres.time1,'filled');
t=scatter (Stats.D50(idxstor,:), Stats.width(idxstor,:), 50, Statsthres.time1(idxstor,:),'filled', 'LineWidth', 1);
xlabel ('D_{50}'); ylabel ('SV'); 
% h=colorbar; ylabel(h, 'required time')
t.MarkerEdgeColor = 'k';
caxis ([0 150])
title ('threshold: slope = 0.05')
% set(gca, 'XScale', 'log')



% thres2: cutoff = 0.005;
subplot(1,3,2), hold on,
scatter (Stats.D50, Stats.width, 50, Statsthres.time2,'filled'); 
t=scatter (Stats.D50(idxstor,:), Stats.width(idxstor,:), 50, Statsthres.time2(idxstor,:),'filled', 'LineWidth', 1);
xlabel ('D_{50}'); % ylabel ('SV'); h=colorbar; ylabel(h, 'required time')
t.MarkerEdgeColor = 'k';
caxis ([0 150])
title ('threshold: slope = 0.005')
% set(gca, 'XScale', 'log')


% thres2: +/- 5%;
subplot(1,3,3), hold on,
scatter (Stats.D50, Stats.width, 50, Statsthres.time3, 'filled'); 
t=scatter (Stats.D50(idxstor,:), Stats.width(idxstor,:), 50, Statsthres.time3(idxstor,:),'filled', 'LineWidth', 1);
xlabel ('D_{50}'); %ylabel ('SV');
h=colorbar; ylabel(h, 'required time (s)')
t.MarkerEdgeColor = 'k';
caxis ([0 150])
title ('threshold: 5% deviation')
% set(gca, 'XScale', 'log')
legend ('field', 'lab')

